/*
使うときは
#include<stdlib.h>
#include <vector> 
#include <algorithm>
#include"SimpleImage.h"
#include"BMPIOlong8byte.h"
#include"SimpleImage3D.h"
が
#include"VideoIO.h"
の前に必要。

 */

void OpenVideo(char *filename,Image3D **R,Image3D **G,Image3D **B,int *sx,int *sy,int *st){
  
  char file_names_txt[] = "tmp_img_file_names.txt";
  char tmp[1000];
  sprintf(tmp,"ls %s | grep .bmp > %s",filename,file_names_txt);
  int sre = system(tmp);
  FILE *fp = fopen(file_names_txt,"r");
  std::vector<char *> file_names;
  char filename_t[1000];
  while(fscanf(fp,"%s",filename_t)!=EOF){
    char *fname_tmp = new char[1000];
    for(int j=0;j<1000;j++)fname_tmp[j] = filename_t[j];
    file_names.push_back(fname_tmp);
    
  }
  fclose(fp);
  std::sort(file_names.begin(),file_names.end());
  
  /* ↑まではImageSetIO.cxxと同じ(ただしincludeは違う) */
  /* 画像のサイズ(sx,sy)と枚数(st)　*/
  
  /* 格納したファイル数をstとして使う */
  (*st) = ((int)(file_names.size()));
  printf("The number of files is %d\n",(*st));

  /* 2D BMP 画像入出力用クラスの宣言とメモリ確保 */
  BMPIO *mybmp = new BMPIO();

  /* 入力フォルダー名(第1引数)とファイル名を結合して開けるパスを代入するための配列 */
  char tmp2[1000];  
  /* 一番目のファイル名を代入 */
  sprintf(tmp2,"%s/%s",filename,file_names[0]);
  printf("%s\n",tmp2);
  /* 画像のサイズをsx,syへ代入 */
  int dsx,dsy;
  mybmp->readBMPSize(&dsx,&dsy,tmp2);
  (*sx)=dsx;
  (*sy)=dsy;
  
  printf("Image size is (%d,%d).\n",(*sx),(*sy));
 
  /* 3次元画像をR,G,B毎にサイズ(sx,sy,st)で宣言しメモリ確保 */
   (*R) = new Image3D((*sx),(*sy),(*st));
  (*G) = new Image3D((*sx),(*sy),(*st));
  (*B) = new Image3D((*sx),(*sy),(*st));
  
    
  int i,j,k;
  /* ファイル名のループ: 実際の連番ファイルを読み込んで3次元画像に代入 */
  for(i=0;i<(*st);i++){

    /* BMP画像を読み込む為にテンポラリーの2D画像をR,G,B毎にサイズ(sx,sy)で宣言しメモリ確保 */
     Image *R_tmp = new Image(dsx,dsy);
    Image *G_tmp = new Image(dsx,dsy);
    Image *B_tmp = new Image(dsx,dsy);
    
     /* i番目のファイル名を入力フォルダー名(第1引数)と結合して代入 */
    sprintf(tmp2,"%s/%s",filename,file_names[i]);
    /* テンポラリーの2D画像をreadBMP()を使って読み込む */
    
    mybmp->readBMP(R_tmp,G_tmp,B_tmp,tmp2);
    
    /* 2D画像のループ: 3D画像のファイルIDがi番目の配列に読み込んだ2D画像をコピー */
    for(j=0;j<dsy;j++)
      for(k=0;k<dsx;k++){
	/* 3D画像の[i][j][k]へ2D画像の[j][k]を代入 */
	(*R)->img[i][j][k] = R_tmp->img[j][k];
	(*G)->img[i][j][k] = G_tmp->img[j][k];
	(*B)->img[i][j][k] = B_tmp->img[j][k]; 
      }
    
    /* テンポラリーの2D画像をdelete */
    delete R_tmp;
    delete G_tmp;
    delete B_tmp;
  }
  
  /* ↓はImageSetIO.cxxと同じ　*/
  for(i=0;i<file_names.size();i++){
    delete [] file_names[i];
  }
  /*BMP入出力クラスをdelete */
  delete mybmp;
}

void SaveVideo(char *foldername,char *filename,Image3D *R,Image3D *G,Image3D *B){
  int i,j,k;
    /* 2D BMP 画像入出力用クラスの宣言とメモリ確保 */
  BMPIO *mybmp = new BMPIO();

   /* ファイル名のループ: 3次元画像をファイルID毎に2D画像に代入してセーブ */
  for(i=0;i<R->st;i++){
    /* BMP画像をセーブする為にテンポラリーの2D画像をR,G,B毎にサイズ(sx,sy)で宣言しメモリ確保 */
    Image *R_tmp = new Image(R->sx,R->sy);
    Image *G_tmp = new Image(R->sx,R->sy);
    Image *B_tmp = new Image(R->sx,R->sy);
    
    /* 2D画像のループ: テンポラリーの2D画像へ3D画像のファイルIDがi番目の配列をコピー */
    for(j=0;j<R->sy;j++)
      for(k=0;k<R->sx;k++){
	/* 2D画像の[j][k]へ3D画像の[i][j][k]をコピー */
	R_tmp->img[j][k] = R->img[i][j][k];
	G_tmp->img[j][k] = G->img[i][j][k];
	B_tmp->img[j][k] = B->img[i][j][k];
      }
    /* セーブするファイル名(第3引数)と出力フォルダー名(第２引数)を結合するための配列 */
    char tmp3[1000];
    
    /* tmp3へファイル名(第3引数)と出力フォルダー名(第２引数)を.bmpの前に_三桁のファイルIDで結合*/
    sprintf(tmp3,"%s/%s_%04d.bmp",foldername,filename,i);
    
    /* テンポラリーの2D画像をtmp3へセーブ */
    mybmp->saveBMP(R_tmp,G_tmp,B_tmp,tmp3);
    
    /* テンポラリーの2D画像をdelete */
    delete R_tmp;
    delete G_tmp;
    delete B_tmp;
  }
  

  
  
   
   /*BMP入出力クラスをdelete */
   delete mybmp;

}

